using System;
using System.IO;
using System.Net;
using System.Text;

namespace Acceptlst
{
  class AcceptlstMain
  {
    public static void Main(string[] args)
    {

      string HOST = "localhost";
      string PORT = "8000";
      string USER = "ormaster";
      string PASSWD = "ormaster";
      string CONTENT_TYPE = "application/xml";


      string URL = "http://" + HOST + ":" + PORT + "/api01rv2/acceptlstv2?class=01";

  /*
       class = 01　は受付中（会計待ち対象）
       class = 02　は会計済（会計済み対象)
       class = 03  は全受付対象

      1.受付日         Acceptance_Date     (IMPLIED)
      2.診療科コード   Department_Code     (IMPLIED)
      3.ドクターコード Physician_Code      (IMPLIED)
      4.診療内容区分   Medical_Information (IMPLIED)

        REQUIRED : 必須   IMPLIED : 任意
  */

      DateTime dtime = DateTime.Now;
      string BODY = @"
<data>
	<acceptlstreq type=""record"">
		<Acceptance_Date type=""string"">" + dtime.ToString("yyyy-MM-dd") + @"</Acceptance_Date>
		<Department_Code type=""string"">01</Department_Code>
		<Physician_Code type=""string"">10001</Physician_Code>
		<Medical_Information type=""string""></Medical_Information>
	</acceptlstreq>
</data>
      ";

      byte[] record_in_byte = Encoding.UTF8.GetBytes(BODY);

      HttpWebRequest req = (HttpWebRequest) HttpWebRequest.Create(URL);
      //req.ProtocolVersion = HttpVersion.Version11;

      req.Method = "POST";
      req.ContentType = CONTENT_TYPE;
      req.ContentLength = record_in_byte.Length;
      req.Credentials = new NetworkCredential(USER, PASSWD);

      Console.WriteLine(BODY);

      HttpWebResponse res = null;
      try
      {
        Stream reqstream = req.GetRequestStream();

        reqstream.Write(record_in_byte, 0, record_in_byte.Length);
        reqstream.Close();

        res = (HttpWebResponse) req.GetResponse();

        Console.WriteLine(res.ResponseUri);
        Console.WriteLine(res.StatusDescription);
      }
      catch (WebException exc)
      {
        if (exc.Status == WebExceptionStatus.ProtocolError)
        {
          HttpWebResponse err = (HttpWebResponse) exc.Response;

          int errcode = (int) err.StatusCode;

          Console.WriteLine(err.ResponseUri);
          Console.WriteLine("{0}:{1}", errcode, err.StatusDescription);

          err.Close();
        }
        else
        {
          Console.WriteLine(exc.Message);
        }
      }

      if (res != null)
      {
        Stream str = res.GetResponseStream();
        StreamReader strread = new StreamReader(str);

        string FOO = strread.ReadToEnd();
        string FILE_NAME = "foo.xml";
        File.WriteAllText(FILE_NAME, FOO);

        strread.Close();
        str.Close();

        res.Close();
      }
    }
  }
}
